<?php 
    /*Feito por Victor Rangel
    Produto Odhen*/
namespace Teknisa\MAN\Controllers;
    
use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO; 
use Teknisa\MAN\Utilities;

class ParamTC extends \Teknisa\MAN\Controllers\TeknisaCrud { 
    
    protected $dataSourceNameArray = array (
        'tiporece'   => 'adm95000_movimentocaixa_tiporece',
        'paramgeral' => 'adm95000_movimentocaixa_paramgeral',
        'caixa'      => 'adm95000_movimentocaixa_caixa'
    );
    protected $parameterBagColumnsArray = array (
        'tiporece' =>  array('NRORG'),
        'paramgeral' =>  array('NRORG'),
        'caixa' =>  array('NRORG', "CDFILIAL", "CDCAIXA")
    );
    
   public function __construct ($crudService, $parameterBag, Manager $dataSourceManager) {
        $this->crudService              = $crudService;
        $this->parameterBag             = $parameterBag;
        $this->dataSourceManager        = $dataSourceManager;
    }
    
    ///find's
    public function findTipoRece(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = $this->dataSourceNameArray['tiporece'];
        $this->parameterBagColumns = $this->parameterBagColumnsArray['tiporece'];
        parent::find($request, $response);
    }
    
    public function findParamGeral(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = $this->dataSourceNameArray['paramgeral'];
        $this->parameterBagColumns = $this->parameterBagColumnsArray['paramgeral'];
        parent::find($request, $response);
    }
    
    public function findCaixa(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = $this->dataSourceNameArray['caixa'];
        $this->parameterBagColumns = $this->parameterBagColumnsArray['caixa'];
        parent::find($request, $response);
    }
    
    ///save's
    public function saveTipoRece(DTO\Request $request, DTO\Response $response) {
        $this->dataSourceName = $this->dataSourceNameArray['tiporece'];
        $this->parameterBagColumns = $this->parameterBagColumnsArray['tiporece'];
        parent::save($request, $response);
    }
    
    public function saveParamGeral(DTO\Request $request, DTO\Response $response) {
        $this->dataSourceName = $this->dataSourceNameArray['paramgeral'];
        $this->parameterBagColumns = $this->parameterBagColumnsArray['paramgeral'];
        parent::save($request, $response);
    }
    
    public function saveCaixa(DTO\Request $request, DTO\Response $response) {
        $this->dataSourceName = $this->dataSourceNameArray['caixa'];
        $this->parameterBagColumns = $this->parameterBagColumnsArray['caixa'];
        parent::save($request, $response);
    }
}
?>